Copy (Gradle API 9.3.1)
Description: declaration: package: org.gradle.api.tasks, class: Copy

Package org.gradle.api.tasks

# Class Copy

java.lang.Object
org.gradle.api.internal.AbstractTask
org.gradle.api.DefaultTask
org.gradle.api.internal.ConventionTask
org.gradle.api.tasks.AbstractCopyTask
org.gradle.api.tasks.Copy

All Implemented Interfaces:
  `Comparable<Task>`, `ContentFilterable`, `CopyProcessingSpec`, `CopySourceSpec`, `CopySpec`, `org.gradle.api.internal.DynamicObjectAware`, `org.gradle.api.internal.file.copy.CopySpecSource`, `org.gradle.api.internal.IConventionAware`, `org.gradle.api.internal.TaskInternal`, `Named`, `ExtensionAware`, `Task`, `PatternFilterable`, `Configurable<Task>`

Direct Known Subclasses:
  `ProcessResources`

@DisableCachingByDefault(because="Not worth caching") public abstract class Copy extends AbstractCopyTask
Copies files into a destination directory. This task can also rename and filter files as it copies. The task implements `CopySpec` for specifying what to copy.

Examples:

     task copyDocs(type: Copy) {
         from 'src/main/doc'
         into 'build/target/doc'
     }

     //for Ant filter
     import org.apache.tools.ant.filters.ReplaceTokens

     //for including in the copy task
     def dataContent = copySpec {
         from 'src/data'
         include '*.data'
     }

     task initConfig(type: Copy) {
         from('src/main/config') {
             include '**/*.properties'
             include '**/*.xml'
             filter(ReplaceTokens, tokens: [version: '2.3.1'])
         }
         from('src/main/config') {
             exclude '**/*.properties', '**/*.xml'
         }
         from('src/main/languages') {
             rename 'EN_US_(.*)', '$1'
         }
         into 'build/target/config'
         exclude '**/*.bak'

         includeEmptyDirs = false

         with dataContent
     }

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface org.gradle.api.Named

  `Named.Namer`

- ## Field Summary

  ### Fields inherited from interface org.gradle.api.Task

  `TASK_ACTION, TASK_CONSTRUCTOR_ARGS, TASK_DEPENDS_ON, TASK_DESCRIPTION, TASK_GROUP, TASK_NAME, TASK_OVERWRITE, TASK_TYPE`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Copy()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected org.gradle.api.internal.file.copy.CopyAction`
  `createCopyAction()`
  `protected org.gradle.api.internal.file.copy.CopySpecInternal`
  `createRootSpec()`
  `File`
  `getDestinationDir()`
  Returns the directory to copy files into.
  `org.gradle.api.internal.file.copy.DestinationRootCopySpec`
  `getRootSpec()`
  `void`
  `setDestinationDir(File destinationDir)`
  Sets the directory to copy files into.

  ### Methods inherited from class org.gradle.api.tasks.AbstractCopyTask

  `copy, createCopyActionExecuter, dirPermissions, eachFile, eachFile, exclude, exclude, exclude, exclude, expand, expand, filePermissions, filesMatching, filesMatching, filesNotMatching, filesNotMatching, filter, filter, filter, filter, from, from, from, getDirectoryFileTreeFactory, getDirPermissions, getDocumentationRegistry, getDuplicatesStrategy, getExcludes, getFileLookup, getFilePermissions, getFileResolver, getFileSystem, getFilteringCharset, getIncludeEmptyDirs, getIncludes, getInstantiator, getMainSpec, getObjectFactory, getPropertyFactory, getSource, include, include, include, include, into, into, into, isCaseSensitive, rename, rename, rename, rename, setCaseSensitive, setDuplicatesStrategy, setExcludes, setFilteringCharset, setIncludeEmptyDirs, setIncludes, with`

  ### Methods inherited from class org.gradle.api.internal.ConventionTask

  `conventionMapping, conventionMapping, getConventionMapping`

  ### Methods inherited from class org.gradle.api.DefaultTask

  `compareTo, configure, dependsOn, doFirst, doFirst, doFirst, doLast, doLast, doLast, finalizedBy, getActions, getAnt, getDependsOn, getDescription, getDestroyables, getDidWork, getEnabled, getExtensions, getFinalizedBy, getGroup, getInputs, getLocalState, getLogger, getLogging, getMustRunAfter, getName, getOutputs, getPath, getProject, getShouldRunAfter, getState, getTaskDependencies, getTemporaryDir, getTimeout, hasProperty, mustRunAfter, onlyIf, onlyIf, onlyIf, property, setActions, setDependsOn, setDescription, setDidWork, setEnabled, setFinalizedBy, setGroup, setMustRunAfter, setOnlyIf, setOnlyIf, setOnlyIf, setProperty, setShouldRunAfter, shouldRunAfter, usesService`

  ### Methods inherited from class org.gradle.api.internal.AbstractTask

  `acceptServiceReferences, appendParallelSafeAction, doNotTrackState, getAsDynamicObject, getIdentityPath, getImpliesSubProjects, getLifecycleDependencies, getOnlyIf, getReasonNotToTrackState, getReasonTaskIsIncompatibleWithConfigurationCache, getRequiredServices, getServices, getSharedResources, getStandardOutputCapture, getTaskActions, getTaskIdentity, getTemporaryDirFactory, hasTaskActions, injectIntoNewInstance, isCompatibleWithConfigurationCache, isEnabled, isHasCustomActions, notCompatibleWithConfigurationCache, prependParallelSafeAction, setImpliesSubProjects`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface org.gradle.api.Task

  `doNotTrackState, notCompatibleWithConfigurationCache`

- ## Constructor Details

  - ### Copy

    public Copy()

- ## Method Details

  - ### createCopyAction

    protected org.gradle.api.internal.file.copy.CopyAction createCopyAction()
    Specified by:
      `createCopyAction` in class `AbstractCopyTask`

  - ### createRootSpec

    protected org.gradle.api.internal.file.copy.CopySpecInternal createRootSpec()
    Overrides:
      `createRootSpec` in class `AbstractCopyTask`

  - ### getRootSpec

    public org.gradle.api.internal.file.copy.DestinationRootCopySpec getRootSpec()
    Specified by:
      `getRootSpec` in interface `org.gradle.api.internal.file.copy.CopySpecSource`
    Overrides:
      `getRootSpec` in class `AbstractCopyTask`

  - ### getDestinationDir

    @OutputDirectory public File getDestinationDir()
    Returns the directory to copy files into.
    Returns:
      The destination dir.

  - ### setDestinationDir

    public void setDestinationDir(File destinationDir)
    Sets the directory to copy files into. This is the same as calling `AbstractCopyTask.into(Object)` on this task.
    Parameters:
      `destinationDir` - The destination directory. Must not be null.